/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.niederschrift.boundary;

import de.ivu.elect.business.niederschrift.entity.Niederschrift;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class NiederschriftDAO extends AbstractNiederschriftDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Niederschrift niederschrift){
    getEntityManager().persist(niederschrift);
  }

  public void remove(Niederschrift niederschrift){
    getEntityManager().remove(niederschrift);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: KuerzelSchnelleingabeNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Niederschrift obj WHERE obj.wahldurchfuehrungsgebiet.wahl.kennzeichen IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.wahl.kennzeichen) = UPPER(?1) AND obj.wahldurchfuehrungsgebiet.wahl.wahltermin.wahldatum = ?2 AND obj.wahldurchfuehrungsgebiet.nummer IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.nummer) = UPPER(?3) AND obj.niederschriftArt = ?4<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Niederschrift> findByKuerzelSchnelleingabe( @javax.annotation.Nonnull java.lang.String wahlKennzeichen,  @javax.annotation.Nonnull java.util.Date wahlWahldatum,  @javax.annotation.Nonnull java.lang.String gebietNummer,  @javax.annotation.Nonnull de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByKuerzelSchnelleingabe" ,  wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByKuerzelSchnelleingabe( wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  ));
        }
        return (java.util.List<Niederschrift>) cached;
        }
            return super.findByKuerzelSchnelleingabe( wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet.wahl = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Niederschrift> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Niederschrift>) cached;
        }
            return super.findByWahl( wahl  );
            }
                                        
        /**
        * Name: WahldurchfuehrungsgebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Niederschrift> findByWahldurchfuehrungsgebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByWahldurchfuehrungsgebiet" ,  wahldurchfuehrungsgebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahldurchfuehrungsgebiet( wahldurchfuehrungsgebiet  ));
        }
        return (java.util.List<Niederschrift>) cached;
        }
            return super.findByWahldurchfuehrungsgebiet( wahldurchfuehrungsgebiet  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}